## Setup Game World
## This creates fighters and assigns initial rankings

label setupGameWorld:
        
    scene bg bkgnd1: 
        zoom 1.0
        xalign 1.0
        yalign 1.0
        
    show screen gui

    $ x = 0
    $ monthDays = 0
    
    $ ui.text("Creating Boxers: 1-25", size=36, xpos=640, ypos=360, xanchor=0.5, yanchor=0.5, xalign=0.5, yalign=0.5)
    $ renpy.pause(0.00000000000000001)
    
    while x < totalBoxers:
        
#        $ ui.text("Creating Boxers: %u" % x, size=36, xpos=640, ypos=360, xanchor=0.5, yanchor=0.5, xalign=0.5, yalign=0.5)
#        $ renpy.pause(0.000000001)
        
        if x == 25:
            $ ui.text("Creating Boxers: 26-50", size=36, xpos=640, ypos=360, xanchor=0.5, yanchor=0.5, xalign=0.5, yalign=0.5)
            $ renpy.pause(0.00000000000000001)
        elif x == 50:
            $ ui.text("Creating Boxers: 51-75", size=36, xpos=640, ypos=360, xanchor=0.5, yanchor=0.5, xalign=0.5, yalign=0.5)
            $ renpy.pause(0.00000000000000001)
        elif x == 75:
            $ ui.text("Creating Boxers: 76-100", size=36, xpos=640, ypos=360, xanchor=0.5, yanchor=0.5, xalign=0.5, yalign=0.5)
            $ renpy.pause(0.00000000000000001)
        
        $ boxerFirstName[x] = firstNames[renpy.random.randint(0,totalFirstNames)]
        $ boxerSurname[x] = surnames[renpy.random.randint(0,totalSurnames)]
        
        # Calculate birthday and age
        
        $ boxerBirthYear[x] = renpy.random.randint((year - 35),(year - 19))
        $ boxerBirthMonth[x] = renpy.random.randint(1,12)
        
        if boxerBirthMonth[x] == 2:
            $ monthDays = 28
        elif boxerBirthMonth[x] == 1 or boxerBirthMonth[x] == 3 or boxerBirthMonth[x] == 5 or boxerBirthMonth[x] == 7 or boxerBirthMonth[x] == 8 or boxerBirthMonth[x] == 10 or boxerBirthMonth[x] == 12:
            $ monthDays = 31
        elif boxerBirthMonth[x] == 4 or boxerBirthMonth[x] == 6 or boxerBirthMonth[x] == 9 or boxerBirthMonth[x] == 11:
            $ monthDays = 30
            
        $ boxerBirthDay[x] = renpy.random.randint(1,monthDays)
        
        if boxerBirthMonth[x] < month or (boxerBirthMonth[x] == month and boxerBirthDay[x] <= day):
            $ boxerAge[x] = year - boxerBirthYear[x]
        else:
            $ boxerAge[x] = (year - boxerBirthYear[x])-1
        
        $ boxerRecovery[x] = renpy.random.randint(1,20)
        $ boxerStrength[x] = renpy.random.randint(1,20)
        $ boxerStamina[x] = renpy.random.randint(1,20)
        $ boxerChin[x] = renpy.random.randint(1,20)
        $ boxerToughness[x] = renpy.random.randint(1,20)
        $ boxerIntelligence[x] = renpy.random.randint(1,20)
        $ boxerAccuracy[x] = renpy.random.randint(1,20)
        $ boxerDefence[x] = renpy.random.randint(1,20)
        $ boxerDetermination[x] = renpy.random.randint(1,20)
        $ boxerAwareness[x] = renpy.random.randint(1,20)
        $ boxerDodging[x] = renpy.random.randint(1,20)
        $ boxerHandSpeed[x] = renpy.random.randint(1,20)
        $ boxerFootwork[x] = renpy.random.randint(1,20)
        $ boxerCuts[x] = renpy.random.randint(1,20)
        $ boxerOverallRating[x] = int((boxerDetermination[x] + boxerRecovery[x] + boxerStrength[x] + boxerStamina[x] + boxerChin[x] + boxerToughness[x] + boxerIntelligence[x] + boxerAccuracy[x] + boxerDefence[x] + boxerAwareness[x] + boxerDodging[x] + boxerHandSpeed[x] + boxerFootwork[x] + boxerCuts[x]) / 14)

        $ boxerEmotionOverall[x] = int((boxerEmotionRecord[x] + boxerEmotionStable[x] + boxerEmotionTraining[x]) / 3)
        
        $ boxerLicenseNo[x] = x
        $ boxerRanking[x] = x+1
        $ rankingSlot[x] = x
        $ boxerHappyWithPlayer[x] = 1
        $ x += 1
        
    $ ui.text("Calculating Initial Rankings...\n(may take 20-30 seconds)", size=36, xpos=640, ypos=360, xanchor=0.5, yanchor=0.5, xalign=0.5, yalign=0.5)
    $ renpy.pause(0.000000001)

    call calculateRankings
    
    call createFighterContracts
    
    hide screen gui
    
    scene bg office_bkgnd:
        zoom 1.0
        xalign 1.0
        yalign 1.0
    
    show tracy main at center
    
    tracy "You must now choose from one to three fighters to manage from the six available rookies."
    
    call stableChoice
        
    scene bg bkgnd1: 
        zoom 1.0
        xalign 1.0
        yalign 1.0
        
    show screen gui
    
    call createInitialCards
        
    return
        
        
label calculateRankings:

    $ y = 0
    $ rankingSwitchSlot = 0
    $ rankingSlot[y] = boxerLicenseNo[y]
    $ rankingSlot[y+1] = boxerLicenseNo[y+1]

    while y < 30:
        
        if y > 0:
            if boxerOverallRating[rankingSlot[y]] > boxerOverallRating[rankingSlot[y-1]]:
                $ rankingSwitchSlot = rankingSlot[y]
                $ rankingSlot[y] = rankingSlot[y-1]
                $ rankingSlot[y-1] = rankingSwitchSlot
                $ boxerRanking[rankingSlot[y]] = (y)+1
                $ boxerRanking[rankingSlot[y-1]] = (y-1)+1
                $ y = y - 2
                if y < 0:
                    $ y = 0
            else:
                $ boxerRanking[rankingSlot[y]] = (y)+1
                $ y += 1
        else:
            if boxerOverallRating[rankingSlot[y]] < boxerOverallRating[rankingSlot[y+1]]:
                $ rankingSwitchSlot = rankingSlot[y]
                $ rankingSlot[y] = rankingSlot[y+1]
                $ rankingSlot[y+1] = rankingSwitchSlot
                $ boxerRanking[rankingSlot[y]] = (y)+1
                $ boxerRanking[rankingSlot[y+1]] = (y+1)+1
                $ y = y - 2
                if y < 0:
                    $ y = 0
            else:
                $ boxerRanking[rankingSlot[y]] = (y)+1
                $ y += 1

    return
    
label createInitialCards:
    
    $ advanceCount = 1
    
    $ advanceDay = day
    $ advanceMonth = month
    $ advanceYear = year
    
    # Event 0 - Set Date
    
    while advanceCount < 6:
        $ advanceDay += 1
        
        if advanceMonth == 2:
            if isLeapYear == 1:
                $ monthDays = 29
            else:
                $ monthDays = 28
        elif advanceMonth == 1 or advanceMonth == 3 or advanceMonth == 5 or advanceMonth == 7 or advanceMonth == 8 or advanceMonth == 10 or advanceMonth == 12:
            $ monthDays = 31
        elif advanceMonth == 4 or advanceMonth == 6 or advanceMonth == 9 or advanceMonth == 11:
            $ monthDays = 30
            
        if advanceDay > monthDays:
            $ advanceDay = 1
            $ advanceMonth += 1
        
            if advanceMonth == 13: 
                $ advanceMonth = 1
                $ advanceYear += 1
        
        $ advanceCount += 1
        
    $ eventYear[0] = advanceYear
    $ eventMonth[0] = advanceMonth
    $ eventDay[0] = advanceDay
    
    # Event 1 - Set Date
    
    while advanceCount < 13:
        $ advanceDay += 1
        
        if advanceMonth == 2:
            if isLeapYear == 1:
                $ monthDays = 29
            else:
                $ monthDays = 28
        elif advanceMonth == 1 or advanceMonth == 3 or advanceMonth == 5 or advanceMonth == 7 or advanceMonth == 8 or advanceMonth == 10 or advanceMonth == 12:
            $ monthDays = 31
        elif advanceMonth == 4 or advanceMonth == 6 or advanceMonth == 9 or advanceMonth == 11:
            $ monthDays = 30
            
        if advanceDay > monthDays:
            $ advanceDay = 1
            $ advanceMonth += 1
        
            if advanceMonth == 13: 
                $ advanceMonth = 1
                $ advanceYear += 1
        
        $ advanceCount += 1
    
    $ eventYear[1] = advanceYear
    $ eventMonth[1] = advanceMonth
    $ eventDay[1] = advanceDay
    
    # Event 2 - Set Date
    
    while advanceCount < 20:
        $ advanceDay += 1
        
        if advanceMonth == 2:
            if isLeapYear == 1:
                $ monthDays = 29
            else:
                $ monthDays = 28
        elif advanceMonth == 1 or advanceMonth == 3 or advanceMonth == 5 or advanceMonth == 7 or advanceMonth == 8 or advanceMonth == 10 or advanceMonth == 12:
            $ monthDays = 31
        elif advanceMonth == 4 or advanceMonth == 6 or advanceMonth == 9 or advanceMonth == 11:
            $ monthDays = 30
            
        if advanceDay > monthDays:
            $ advanceDay = 1
            $ advanceMonth += 1
        
            if advanceMonth == 13: 
                $ advanceMonth = 1
                $ advanceYear += 1
        
        $ advanceCount += 1
    
    $ eventYear[2] = advanceYear
    $ eventMonth[2] = advanceMonth
    $ eventDay[2] = advanceDay
    
    # Event 3 - Set Date
    
    while advanceCount < 27:
        $ advanceDay += 1
        
        if advanceMonth == 2:
            if isLeapYear == 1:
                $ monthDays = 29
            else:
                $ monthDays = 28
        elif advanceMonth == 1 or advanceMonth == 3 or advanceMonth == 5 or advanceMonth == 7 or advanceMonth == 8 or advanceMonth == 10 or advanceMonth == 12:
            $ monthDays = 31
        elif advanceMonth == 4 or advanceMonth == 6 or advanceMonth == 9 or advanceMonth == 11:
            $ monthDays = 30
            
        if advanceDay > monthDays:
            $ advanceDay = 1
            $ advanceMonth += 1
        
            if advanceMonth == 13: 
                $ advanceMonth = 1
                $ advanceYear += 1
        
        $ advanceCount += 1
    
    $ eventYear[3] = advanceYear
    $ eventMonth[3] = advanceMonth
    $ eventDay[3] = advanceDay
    
    # Event 4 - Set Date
    
    while advanceCount < 34:
        $ advanceDay += 1
        
        if advanceMonth == 2:
            if isLeapYear == 1:
                $ monthDays = 29
            else:
                $ monthDays = 28
        elif advanceMonth == 1 or advanceMonth == 3 or advanceMonth == 5 or advanceMonth == 7 or advanceMonth == 8 or advanceMonth == 10 or advanceMonth == 12:
            $ monthDays = 31
        elif advanceMonth == 4 or advanceMonth == 6 or advanceMonth == 9 or advanceMonth == 11:
            $ monthDays = 30
            
        if advanceDay > monthDays:
            $ advanceDay = 1
            $ advanceMonth += 1
        
            if advanceMonth == 13: 
                $ advanceMonth = 1
                $ advanceYear += 1
        
        $ advanceCount += 1
    
    $ eventYear[4] = advanceYear
    $ eventMonth[4] = advanceMonth
    $ eventDay[4] = advanceDay
    
    # Book Matches
    
    $ eventIndex = 0
    
    while eventIndex < 1:
        $ x = 0
        $ matchBookingStart = (((eventIndex * 5) + 1) - 1)
        $ matchBooking = matchBookingStart 
        
        while matchBooking < (matchBookingStart + 5):
            
            $ ui.text("Booking Match No.%u" % matchBooking, size=64, xpos=640, ypos=360, xanchor=0.5, yanchor=0.5, xalign=0.5, yalign=0.5)
            $ renpy.pause(0.000000001)
        
            while x == 0:
                $ redFighter[matchBooking] = renpy.random.randint(0,totalBoxers-1)
                
                # Check fighter isn't already booked
                 
                if boxerMatchBooked[redFighter[matchBooking]] == 1 or boxerEnergy[redFighter[matchBooking]] < 60 or boxerPlayerStable[redFighter[matchBooking]] == 1:
                    $ x = 0
                else:
                    $ boxerMatchBooked[redFighter[matchBooking]] = 1
                    $ x = 1
            $ x = 0
            
            $ upperOpponentLimit = (boxerRanking[redFighter[matchBooking]] - 11)
            
            if upperOpponentLimit < 0:
                $ upperOpponentLimit = 0
                
            $ lowerOpponentLimit = (boxerRanking[redFighter[matchBooking]] + 4)
            
            if lowerOpponentLimit > (totalBoxers-1):
                $ lowerOpponentLimit = (totalBoxers-1)
            
            while x == 0:
                $ blueFighter[matchBooking] = rankingSlot[renpy.random.randint(upperOpponentLimit,lowerOpponentLimit)]
                
                # Check fighter isn't already booked or isn't evenly matched with opponent
                 
                if boxerMatchBooked[blueFighter[matchBooking]] == 1 or boxerEnergy[blueFighter[matchBooking]] < 60 or boxerPlayerStable[blueFighter[matchBooking]] == 1:
                    $ x = 0
                else:
                    $ boxerMatchBooked[blueFighter[matchBooking]] = 1
                    $ expectedPurse = 0
                    
                    if (boxerRanking[blueFighter[matchBooking]] - boxerRanking[redFighter[matchBooking]]) >= 10:
                        $ expectedPurse = 80
                    elif (boxerRanking[blueFighter[matchBooking]] - boxerRanking[redFighter[matchBooking]]) < 10 and (boxerRanking[blueFighter[matchBooking]] - boxerRanking[redFighter[matchBooking]]) >= 6:
                        $ expectedPurse = 75
                    elif (boxerRanking[blueFighter[matchBooking]] - boxerRanking[redFighter[matchBooking]]) < 6 and (boxerRanking[blueFighter[matchBooking]] - boxerRanking[redFighter[matchBooking]]) >= 2:
                        $ expectedPurse = 70
                    elif (boxerRanking[blueFighter[matchBooking]] - boxerRanking[redFighter[matchBooking]]) < 2 and (boxerRanking[blueFighter[matchBooking]] - boxerRanking[redFighter[matchBooking]]) >= 0:
                        $ expectedPurse = 60
                    elif (boxerRanking[blueFighter[matchBooking]] - boxerRanking[redFighter[matchBooking]]) < 0 and (boxerRanking[blueFighter[matchBooking]] - boxerRanking[redFighter[matchBooking]]) >= -2:
                        $ expectedPurse = 45
                    elif (boxerRanking[blueFighter[matchBooking]] - boxerRanking[redFighter[matchBooking]]) < -2 and (boxerRanking[blueFighter[matchBooking]] - boxerRanking[redFighter[matchBooking]]) >= -6:
                        $ expectedPurse = 40
                    elif (boxerRanking[blueFighter[matchBooking]] - boxerRanking[redFighter[matchBooking]]) < -6 and (boxerRanking[blueFighter[matchBooking]] - boxerRanking[redFighter[matchBooking]]) >= -8:
                        $ expectedPurse = 30
                    elif (boxerRanking[blueFighter[matchBooking]] - boxerRanking[redFighter[matchBooking]]) < -8:
                        $ expectedPurse = 25
                                    
                    $ proposedPurse = (100 - expectedPurse)
                    $ x = 1
                    
            $ boxerFightsBooked[redFighter[matchBooking]] += 1
            if boxerFightsBooked[redFighter[matchBooking]] >= boxerPromiseFights[redFighter[matchBooking]]:
                $ boxerContractExpiring[redFighter[matchBooking]] = 1
            else:
                $ boxerContractExpiring[redFighter[matchBooking]] = 0
            $ boxerContractTitle[redFighter[matchBooking]] = "None"
            $ boxerNextFightPurse[redFighter[matchBooking]] = expectedPurse
            $ boxerNextFightOpponent[redFighter[matchBooking]] = blueFighter[matchBooking]
            $ boxerNextFightDay[redFighter[matchBooking]] = eventDay[eventIndex]
            $ boxerNextFightMonth[redFighter[matchBooking]] = eventMonth[eventIndex]
            $ boxerNextFightYear[redFighter[matchBooking]] = eventYear[eventIndex]
        
            if boxerNextFightPurse[redFighter[matchBooking]] < boxerPromisePurse[redFighter[matchBooking]]:
                $ boxerEmotionStable[redFighter[matchBooking]] -= 1
                
            $ boxerEmotionOverall[redFighter[matchBooking]] = int((boxerEmotionRecord[redFighter[matchBooking]] + boxerEmotionStable[redFighter[matchBooking]] + boxerEmotionTraining[redFighter[matchBooking]]) / 3)
            
            
            
            $ boxerFightsBooked[blueFighter[matchBooking]] += 1
            if boxerFightsBooked[blueFighter[matchBooking]] >= boxerPromiseFights[blueFighter[matchBooking]]:
                $ boxerContractExpiring[blueFighter[matchBooking]] = 1
            else:
                $ boxerContractExpiring[blueFighter[matchBooking]] = 0
            $ boxerContractTitle[blueFighter[matchBooking]] = "None"
            $ boxerNextFightPurse[blueFighter[matchBooking]] = proposedPurse
            $ boxerNextFightOpponent[blueFighter[matchBooking]] = redFighter[matchBooking]
            $ boxerNextFightDay[blueFighter[matchBooking]] = eventDay[eventIndex]
            $ boxerNextFightMonth[blueFighter[matchBooking]] = eventMonth[eventIndex]
            $ boxerNextFightYear[blueFighter[matchBooking]] = eventYear[eventIndex]
        
            if boxerNextFightPurse[blueFighter[matchBooking]] < boxerPromisePurse[blueFighter[matchBooking]]:
                $ boxerEmotionStable[blueFighter[matchBooking]] -= 1
                
            $ boxerEmotionOverall[blueFighter[matchBooking]] = int((boxerEmotionRecord[blueFighter[matchBooking]] + boxerEmotionStable[blueFighter[matchBooking]] + boxerEmotionTraining[blueFighter[matchBooking]]) / 3)
            
                    
            $ matchBooking += 1
            $ matchesBooked[eventIndex] += 1
            $ x = 0
            
        # sort card
        
        $ redSwitch = 999
        $ blueSwitch = 999
        $ x = matchBookingStart
        
        while x < (matchBookingStart + 5):
            if x < (matchBookingStart + 4):
                if boxerRanking[redFighter[x]] < boxerRanking[blueFighter[x]]:
                    if (boxerRanking[redFighter[x]] < boxerRanking[redFighter[x+1]] and boxerRanking[redFighter[x]] < boxerRanking[blueFighter[x+1]]):
                        $ redSwitch = redFighter[x]
                        $ bluesSwitch = blueFighter[x]
                        $ redFighter[x] = redFighter[x+1]
                        $ blueFighter[x] = blueFighter[x+1]
                        $ redFighter[x+1] = redSwitch
                        $ blueFighter[x+1] = bluesSwitch
                        $ x = matchBookingStart
                    else:
                        $ x += 1
                elif boxerRanking[blueFighter[x]] < boxerRanking[redFighter[x]]:
                    if (boxerRanking[blueFighter[x]] < boxerRanking[redFighter[x+1]] and boxerRanking[blueFighter[x]] < boxerRanking[blueFighter[x+1]]):
                        $ redSwitch = redFighter[x]
                        $ bluesSwitch = blueFighter[x]
                        $ redFighter[x] = redFighter[x+1]
                        $ blueFighter[x] = blueFighter[x+1]
                        $ redFighter[x+1] = redSwitch
                        $ blueFighter[x+1] = bluesSwitch
                        $ x = matchBookingStart
                    else:
                        $ x += 1
            else:
                if boxerRanking[redFighter[x]] < boxerRanking[blueFighter[x]]:
                    if (boxerRanking[redFighter[x]] > boxerRanking[redFighter[x-1]] and boxerRanking[redFighter[x]] > boxerRanking[blueFighter[x-1]]):
                        $ redSwitch = redFighter[x]
                        $ bluesSwitch = blueFighter[x]
                        $ redFighter[x] = redFighter[x-1]
                        $ blueFighter[x] = blueFighter[x-1]
                        $ redFighter[x-1] = redSwitch
                        $ blueFighter[x-1] = bluesSwitch
                        $ x = matchBookingStart
                    else:
                        $ x += 1
                elif boxerRanking[blueFighter[x]] < boxerRanking[redFighter[x]]:
                    if (boxerRanking[blueFighter[x]] > boxerRanking[redFighter[x-1]] and boxerRanking[blueFighter[x]] > boxerRanking[blueFighter[x-1]]):
                        $ redSwitch = redFighter[x]
                        $ bluesSwitch = blueFighter[x]
                        $ redFighter[x] = redFighter[x-1]
                        $ blueFighter[x] = blueFighter[x-1]
                        $ redFighter[x-1] = redSwitch
                        $ blueFighter[x-1] = bluesSwitch
                        $ x = matchBookingStart
                    else:
                        $ x += 1
        
            
        $ cardRun[eventIndex] = 0
        $ eventIndex += 1
    
    return
    
    
label createFighterContracts:

    $ x = 0
    
    $ ui.text("Creating Boxer Contracts: 1-25", size=36, xpos=640, ypos=360, xanchor=0.5, yanchor=0.5, xalign=0.5, yalign=0.5)
    $ renpy.pause(0.00000000000000001)
    
    while x < (totalBoxers - 15):
        
#        $ ui.text("Creating Boxer Contracts: %u" % x, size=36, xpos=640, ypos=360, xanchor=0.5, yanchor=0.5, xalign=0.5, yalign=0.5)
#        $ renpy.pause(0.000000001)
        
        if x == 25:
            $ ui.text("Creating Boxer Contracts: 26-50", size=36, xpos=640, ypos=360, xanchor=0.5, yanchor=0.5, xalign=0.5, yalign=0.5)
            $ renpy.pause(0.00000000000000001)
        elif x == 50:
            $ ui.text("Creating Boxer Contracts: 51-75", size=36, xpos=640, ypos=360, xanchor=0.5, yanchor=0.5, xalign=0.5, yalign=0.5)
            $ renpy.pause(0.00000000000000001)
        elif x == 75:
            $ ui.text("Creating Boxer Contracts: 76-100", size=36, xpos=640, ypos=360, xanchor=0.5, yanchor=0.5, xalign=0.5, yalign=0.5)
            $ renpy.pause(0.00000000000000001)
        
        # Decide what the fighter will want in contract
    
        if boxerAge[x] <= 21:
            $ boxerPromiseFights[x] = 4
        elif boxerAge[x] > 21 and boxerAge[x] <= 25:
            $ boxerPromiseFights[x] = 3
        elif boxerAge[x] > 25 and boxerAge[x] <= 30:
            $ boxerPromiseFights[x] = 4
        elif boxerAge[x] > 30 and boxerAge[x] <= 36: 
            $ boxerPromiseFights[x] = 5
        elif boxerAge[x] > 36:
            $ boxerPromiseFights[x] = 3
            
        if boxerRanking[x] > 80:
            $ boxerPromisePurse[x] = 20
        elif boxerRanking[x] <= 80 and boxerRanking[x] > 60:
            $ boxerPromisePurse[x] = 25
        elif boxerRanking[x] <= 60 and boxerRanking[x] > 40:
            $ boxerPromisePurse[x] = 30
        elif boxerRanking[x] <= 40 and boxerRanking[x] > 20:
            $ boxerPromisePurse[x] = 35
        elif boxerRanking[x] <= 20 and boxerRanking[x] > 10:
            $ boxerPromisePurse[x] = 40
        elif boxerRanking[x] <= 10 and boxerRanking[x] > 5:
            $ boxerPromisePurse[x] = 45
        elif boxerRanking[x] <= 5 and boxerRanking[x] > 1:
            $ boxerPromisePurse[x] = 50
        elif boxerRanking[x] == 1:
            $ boxerPromisePurse[x] = 60
        
        if boxerRanking[x] > 80:
            $ boxerPromiseRank[x] = boxerRanking[x] - 10
        elif boxerRanking[x] <= 80 and boxerRanking[x] > 60:
            $ boxerPromiseRank[x] = boxerRanking[x] - 15
        elif boxerRanking[x] <= 60 and boxerRanking[x] > 20:
            $ boxerPromiseRank[x] = boxerRanking[x] - 20
        elif boxerRanking[x] <= 20 and boxerRanking[x] > 10:
            $ boxerPromiseRank[x] = boxerRanking[x] - 10
            if boxerPromiseRank[x] < 1:
                $ boxerPromiseRank[x] = 1
        elif boxerRanking[x] <= 10 and boxerRanking[x] > 5:
            $ boxerPromiseRank[x] = boxerRanking[x] - 5
            if boxerPromiseRank[x] < 1:
                $ boxerPromiseRank[x] = 1
        elif boxerRanking[x] <= 5 and boxerRanking[x] > 2:
            $ boxerPromiseRank[x] = 2
        elif boxerRanking[x] <= 2:
            $ boxerPromiseRank[x] = 1
            
        if boxerRanking[x] <= 15:
            $ boxerPromiseTitleShot[x] = "World"
        else:
            $ boxerPromiseTitleShot[x] = "None"
            
        $ boxerContractExpired[x] = 0
            
        $ boxersOnContract += 1
        
        $ x += 1

    return